<%
Class DynLink
	Dim Name, HRef, Info
End Class

Class DynLinks
	Private arrLinks()
	Private bIsEmpty

	Private Sub Class_Initialize()
		bIsEmpty = True	
	End Sub
	
	Public Property Get Links(index)
		Set Links = arrLinks(index)
	End Property
	
	Public Property Get Count
		If Not bIsEmpty Then 
			Count = UBound(arrLinks)+1
		Else 
			Count = 0 
		End If
	End Property

	Sub Load(strFile)
		Dim fso, f, o, i
		
		Set fso = Server.CreateObject("Scripting.FileSystemObject")
		Set f = fso.OpenTextFile(Server.MapPath(strFile), 1, True)
		
		If f.AtEndOfStream Then Exit Sub
		
		i = f.ReadLine
		If i > 0 Then		
			ReDim arrLinks(i-1)
			While i > 0
				i = i - 1
				Set o = New DynLink
				o.Name = f.ReadLine
				o.HRef = f.ReadLine
				o.Info = f.ReadLine
				
				Set arrLinks(i) = o
			WEnd
			bIsEmpty = False
		Else
			ReDim arrLinks(0)
			bIsEmpty = True
		End If
	End Sub
	
	Sub Save(strFile)
		Dim fso, f, o, i
		
		Set fso = Server.CreateObject("Scripting.FileSystemObject")
		Set f = fso.CreateTextFile(Server.MapPath(strFile), True)
		
		If Not bIsEmpty Then
			f.WriteLine(UBound(arrLinks)+1)		
			For i = 0 To UBound(arrLinks)
				Set o = arrLinks(i)
				f.WriteLine(o.Name)
				f.WriteLine(o.HRef)
				f.WriteLine(o.Info)
			Next
		Else
			f.WriteLine(0)		
		End If
		f.Close		
	End Sub 

	Sub AddLink(strName, strHRef, strInfo)
		Dim o, i
		
		Set o = New DynLink
		o.Name = strName
		o.HRef = strHRef
		o.Info = strInfo
		
		If Not bIsEmpty Then 
			i = UBound(arrLinks)+1
			ReDim Preserve arrLinks(i)
		Else 
			i = 0
			ReDim arrLinks(i)
		End If
		Set arrLinks(i) = o
		bIsEmpty = False
	End Sub
	
	Sub RemoveLink(strName)
		Dim i, o, j, a()
		
		j = 0
		If UBound(arrLinks) > 0 Then
			ReDim a(UBound(arrLinks)-1)
			For i = 0 To UBound(arrLinks)
				If arrLinks(i).Name <> strName Then 
					Set a(j) = arrLinks(i)
					j = j + 1
				End If
			Next
			arrLinks = a
		Else
			ReDim arrLinks(0)
			bIsEmpty = True
		End If		
	End Sub

End Class
%>